package fxHiihtorekisteri;

import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.ResourceBundle;
import Tietorakenteet.Hiihto;
import Tietorakenteet.Jasen;
import Tietorakenteet.Rekisteri;
import Tietorakenteet.SailoException;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.StringGrid;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;

/**
 * @author MHo
 * @version 13.1.2020
 * Hiihtorekisteri, johon voi lisätä jäseniä ja heille hiihtosuorituksia.
 * Jäseniä voi myös muokata ja poistaa.
 * Hiihtoja voi muokata, mutta poisto ei vielä toimi.
 */
public class HiihtorekisteriGUIController implements Initializable {

    @FXML private MenuItem ylanappiTallenna;
    @FXML private MenuItem ylanappiTulosta;
    @FXML private MenuItem ylanappiLisaaHiihtaja;
    @FXML private MenuItem ylanappiPoistaHiihtaja;
    @FXML private MenuItem ylanappiLopeta;
    @FXML private MenuItem ylanappiKayttoOhje;
    @FXML private MenuItem ylanappiTietoja;
    
    @FXML private ComboBoxChooser<String> cbKentat;
    @FXML private TextField Hakuehto;
    @FXML private ListChooser<Jasen> chooserJasenet;
    
    @FXML private GridPane gridJasen;
    @FXML private TextField kenttaENimi;
    @FXML private TextField kenttaSNimi;
    @FXML private TextField kenttaSAika;
    @FXML private TextField kenttaPKunta;
    @FXML private TextField kenttaPuh;
    @FXML private TextField kenttaEmail;
    @FXML private TextField kenttaLVuosi;
    @FXML private TextField kenttaKm;
    
    @FXML private StringGrid<Hiihto> gridHiihdot;

    @FXML private Button nappiLisaaHiihto;
    @FXML private Button nappiTulosta;
    
    private Rekisteri rekisteri;
    private Jasen jasenKohdalla;
    private static Jasen apujasen = new Jasen(); 
    
    @Override
    public void initialize(URL url, ResourceBundle bundle) {
        alusta();
    }
    
    @FXML void handleHakuehto() {
        hae(0);
    }
     
    @FXML void handleLisaaHiihtaja() {
        lisaaHiihtaja();        
    }
    
    @FXML void handleLisaaHiihto() {
        lisaaHiihto();
    }
    
    @FXML void handleMuokkaa() {
        muokkaa();
    }
    
    @FXML void handleTulosta() {
        tulosta(jasenKohdalla);
    }

    @FXML void handlePoistaHiihtaja() {
        poistaHiihtaja();
    }

    @FXML private String handleTallenna() {
       return tallenna();
    }
    
    @FXML void handleLopeta() {
        handleTallenna();
        Platform.exit();
    }
    
    @FXML void handleKayttoOhje() { ModalController.showModal(HiihtorekisteriGUIController.class.getResource("Ohje.fxml"), "Käyttöohje", null, "");
    }

    @FXML void handleTietoja() { ModalController.showModal(HiihtorekisteriGUIController.class.getResource("Tietoja.fxml"), "Tietoja", null, "");
    }

    
    /**
     * @param rekisteri jota käytetään
     */
    public void setRekisteri(Rekisteri rekisteri) {
        this.rekisteri = rekisteri;
        alusta();
        lueTiedosto();
    }
    
    
    /**
     * Alustaa listan jäsenistä
     */
    protected void alusta() {
        chooserJasenet.clear();
        chooserJasenet.addSelectionListener(e -> naytaJasen());
        
        cbKentat.clear();
            cbKentat.add(apujasen.getKysymys(2), null);
            cbKentat.add(apujasen.getKysymys(4), null);
        cbKentat.getSelectionModel().select(0);
        
        TextField[] kentat = new TextField[]{kenttaENimi, kenttaSNimi, kenttaSAika, kenttaPKunta, kenttaPuh, kenttaEmail, kenttaLVuosi};
               //TietueGUIController.luoKentat(gridJasen, jasenKohdalla); 
        for (TextField edit: kentat)
            if ( edit != null ) {  
                edit.setEditable(false);  
                //edit.setOnMouseClicked(e -> { if ( e.getClickCount() > 1 ) muokkaa(getFieldId(e.getSource(),0)); });  
                //edit.focusedProperty().addListener((a,o,n) -> kentta = getFieldId(edit,kentta));  
            } 
    }
    
    
    /**
     * Alustaa kerhon lukemalla sen valitun nimisestä tiedostosta
     * @return null jos onnistuu, muuten virhe tekstinä
     */
    protected String lueTiedosto() {
        try {
            rekisteri.lueTiedostosta();
            hae(0);
            return null;
        } catch (SailoException e) {
            hae(0);
            String virhe = e.getMessage(); 
            if ( virhe != null ) Dialogs.showMessageDialog(virhe);
            return virhe;
        }
     }
    
    
    /**
     * Hakee jäsenten tiedot listaan
     * @param jnr jäsenen numero, joka aktivoidaan haun jälkeen
     */
    protected void hae(int jnr) {
        int jnro = jnr; // jnro jäsenen numero, joka aktivoidaan haun jälkeen 
        if ( jnro <= 0 ) { 
            Jasen kohdalla = jasenKohdalla; 
            if ( kohdalla != null ) jnro = kohdalla.getID(); 
        }
        
        int k;
        k = 0;
        if (cbKentat.getSelectionModel().getSelectedIndex() == 0) k = 2;
        if (cbKentat.getSelectionModel().getSelectedIndex() == 1) k = 4;
        //int k = cbKentat.getSelectionModel().getSelectedIndex() + 2; //apujasen.ekaKentta(); 
        String ehto = Hakuehto.getText(); 
        if (ehto.indexOf('*') < 0) ehto = "*" + ehto + "*";
        
        chooserJasenet.clear();
        
        int index = 0;
        Collection<Jasen> jasenet;
        if (ehto == "**") naytaKaikki();
        else {
                try {
                    jasenet = rekisteri.etsi(ehto, k);
                    int i = 0;
                    for (Jasen jasen:jasenet) {
                        if (jasen.getID() == jnro) index = i;
                        chooserJasenet.add(jasen.getNimi(), jasen);
                        i++;
                    }
                } catch (SailoException ex) {
                    Dialogs.showMessageDialog("Jäsenen hakemisessa ongelmia! " + ex.getMessage());
                }
                chooserJasenet.setSelectedIndex(index); // tästä tulee muutosviesti joka näyttää jäsenen
            }
    }

    
    /*
     * Näytetään kaikki rekisterin hiihtäjät
     */
    private void naytaKaikki() {
        for (int i = 1; i < rekisteri.getLkm(); i++) {
            chooserJasenet.add(rekisteri.annaJasen(i).getNimi(), rekisteri.annaJasen(i));
        }
    }

    
    /**
     * Näyttää listasta valitun jäsenen tiedot
     */
    protected void naytaJasen() {
        jasenKohdalla = chooserJasenet.getSelectedObject();
        if (jasenKohdalla == null) return;
        TextField[] kentat = new TextField[] {kenttaENimi, kenttaSNimi, kenttaSAika, kenttaPKunta, kenttaPuh, kenttaEmail, kenttaLVuosi, kenttaKm};
        TietueGUIController.naytaTietue(kentat, jasenKohdalla);
        laskeKm();
        naytaHiihdot(jasenKohdalla);
    }
    
    
    /**
     * Näyetään valitun jäsenen yhteiskilometrit
     */
    private void laskeKm() {
        kenttaKm.setText(rekisteri.laskeKm(jasenKohdalla));
    }

    
    /**
     * Muokkaa olemassaolevaa jäsentä
     */
    public void muokkaa() {
        if ( jasenKohdalla == null ) return; 
        try {
        Jasen jasen;
        jasen = TietueGUIController.kysyTietue(null, jasenKohdalla.clone(), rekisteri);
        if ( jasen == null ) return; 
        rekisteri.korvaaTaiLisaa(jasen);
        hae(jasen.getID());
        } catch (CloneNotSupportedException e) {
            //
        } catch (SailoException e) { 
            Dialogs.showMessageDialog(e.getMessage()); 
        }
        laskeKm();
    }
    
    
    /**
     * Luodaan rekisteriin uusi jäsen
     */
    private void lisaaHiihtaja() {
        Jasen uusi = new Jasen();
        uusi = TietueGUIController.kysyTietue(null, uusi);  
        if ( uusi == null ) return;
        rekisteri.lisaa(uusi);
        hae(uusi.getID());
    }

    
    private void lisaaHiihto() {
        if ( jasenKohdalla == null ) return;
        Hiihto uusi = new Hiihto(jasenKohdalla.getID());
        uusi  = TietueGUIController.kysyTietue(null, uusi);
        if ( uusi == null ) return;
        rekisteri.lisaaHiihto(uusi);
        naytaHiihdot(jasenKohdalla); 
        gridHiihdot.selectRow(1000);  // järjestetään viimeinen rivi valituksi
    }

    
    /**
     * Näyttää listasta valitun jäsenen hiihdot
     */
    private void naytaHiihdot(Jasen j) {
        if (j == null) return;
        gridHiihdot.clear();
        ArrayList<Hiihto> jasenenHiihdot = rekisteri.getJasenenHiihdot(j.getID());
        //String[] rivi = null;
        for (Hiihto h : jasenenHiihdot) {
            //rivi = h.getTiedot();
            gridHiihdot.add(h, h.getTiedot());
        }
        gridHiihdot.setEditable(false);
    }

    
    /*
     * Poistetaan listalta valittu jäsen
     */
    private void poistaHiihtaja() {
        Jasen jasen = jasenKohdalla;
        if ( jasen == null ) return;
        if ( !Dialogs.showQuestionDialog("Poisto", "Poistetaanko hiihtaja: " + jasen.getNimi(), "Kyllä", "Ei") )
            return;
        rekisteri.poistaHiihtaja(jasen);
        int index = chooserJasenet.getSelectedIndex();
        hae(0);
        chooserJasenet.setSelectedIndex(index);
    }
    
    
    private void tulosta(Jasen j) {
        if (j == null) {
            Dialogs.showMessageDialog("Valitse jäsen, jonka tiedot tulostetaan");
            return;
        }
        TulostaGUIController.tulosta(j, rekisteri);
    }
    
    
    /**
     * @return ilmoitus, onnistuuko tallentaminen vai ei
     */
    public String tallenna() {
        try {
            rekisteri.tallenna();
            Dialogs.showMessageDialog("Tiedot tallennettu");
            return null;
        } catch (SailoException ex) {
            Dialogs.showMessageDialog("Tallennuksessa ongelmia! " + ex.getMessage());
            return ex.getMessage();
        }
    }
}