package fxHiihtorekisteri;

import java.io.PrintStream;
import java.util.ArrayList;

import Tietorakenteet.Hiihto;
import Tietorakenteet.Jasen;
import Tietorakenteet.Rekisteri;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.fxml.FXML;
import javafx.print.PrinterJob;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.web.WebEngine;

/**
 * @author MHo
 * @version 13.1.2020
 */
public class TulostaGUIController implements ModalControllerInterface<Jasen> {

    @FXML private TextArea tulostusAlue;
    @FXML private Button nappiTulosta;
    @FXML private Button nappiPeruuta;
    
    private Rekisteri rekisteri;
    private Jasen jasen;
    
    @FXML void handleTulosta() {
        PrinterJob job = PrinterJob.createPrinterJob();
        if ( job != null && job.showPrintDialog(null) ) {
            WebEngine webEngine = new WebEngine();
            webEngine.loadContent("<pre>" + tulostusAlue.getText() + "</pre>");
            webEngine.print(job);
            job.endJob();
        }
    }
    
    @FXML void handlePeruuta() {
        ModalController.closeStage(nappiPeruuta);
    }
    
    @Override public Jasen getResult() {
        return null;
    }
    
    @Override public void handleShown() {
        //
    }

    @Override public void setDefault(Jasen oletus) {
        jasen = oletus;
    }
    
    /**
     * @param r rekisteri jota käytetään
     * 
     */
    public void setRekisteri(Rekisteri r) {
        rekisteri = r;
        tulosta(tulostusAlue);
    }
    
    /**
     * @param t alue johon tulostetaan
     */
    public void tulosta(TextArea t) {
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(t)) {
            os.println("Tulostetaan kaikki hiihdot");
            ArrayList<Hiihto> jasenenHiihdot = rekisteri.getJasenenHiihdot(jasen.getID());
            for (Hiihto h : jasenenHiihdot) {
                h.tulosta(os);
                os.println("\n");
            }
        }
    }

    
    /**
     * Näyttää tulostusalueessa tekstin
     * @param j jäsen jonka hiihdot tulostetaan
     * @param r rekisteri jota käytetään
     */
    public static void tulosta(Jasen j, Rekisteri r) {
          ModalController.<Jasen, TulostaGUIController>showModal(TulostaGUIController.class.getResource("Tulosta.fxml"),
                                       "Tulostus", null, j, ctrl -> ctrl.setRekisteri(r));
    }
}